/*
 *  file      : src/ntb_desktop.c
 *  project   : b2im
 *  copyright : (C) 2015 by BULIN Claude
 * 
 *  This file is part of b2im project
 * 
 *  b2im is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; version 3.
 * 
 *  b2im is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 * 
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 *  USA
 */


#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif
#include <gtk/gtk.h>
#include <glib.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

// #include <unistd.h>
// #include <sys/types.h>
// #include <signal.h>
#include <dirent.h>
#include <sys/stat.h>

#ifdef ENABLE_STATIC_LIBRARY
	#include "../lib_b2im/lib.h"
#endif

#include "global.h"
#include "configuser.h"


typedef struct {
	gchar		*name;
	GtkWidget	*button;
} STRUCT_LIST_RADIO;


GList	*list_dir = NULL;	// LIST_RADIO

void NtbDesktop_remove_list( void )
{
	GList	*list = NULL;
	STRUCT_LIST_RADIO *struct_list_radio = NULL;

	if( NULL != ( list = g_list_first( list_dir ))) {
		while (list) {
			if( NULL != (struct_list_radio = (STRUCT_LIST_RADIO *)list->data)) {
				
				if( NULL != struct_list_radio->button ) {
					gtk_widget_destroy( struct_list_radio->button );
					struct_list_radio->button = NULL;
				}
				
				if( NULL != struct_list_radio->name ) {
					g_free( struct_list_radio->name );
					struct_list_radio->name = NULL;
				}
				g_free( struct_list_radio );
				struct_list_radio = NULL;
				
				struct_list_radio = list->data = NULL;
			}
			list = g_list_next( list );
		}
		g_list_free( list_dir );
		list_dir = NULL;
	}
}


GList *fileanalyze_recherche_recursive( gchar *Directory )
{
	DIR			*dp;
	struct dirent *entry;
	struct stat statbuf;
	gboolean	bool_desktop_ok = FALSE;
	STRUCT_LIST_RADIO *struct_list_radio = NULL;
	
	if( NULL == (dp = opendir( Directory )) ) return( NULL );
	chdir( Directory );
	while( (entry = readdir(dp)) != NULL ) {
		lstat( entry->d_name, &statbuf );
		if( S_ISDIR( statbuf.st_mode )) {
			if( strcmp( ".", entry->d_name ) == 0 || strcmp( "..", entry->d_name ) == 0 ) continue;
			if( strcmp( "build", entry->d_name ) == 0 ||
				strcmp( "shared", entry->d_name ) == 0 || 
				strcmp( "sysmenu", entry->d_name ) == 0 ) continue;
			
			struct_list_radio = (STRUCT_LIST_RADIO *)g_malloc0( sizeof(STRUCT_LIST_RADIO) );
			struct_list_radio->name   = g_strdup( entry->d_name );
			struct_list_radio->button = NULL;
			list_dir = g_list_append( list_dir, struct_list_radio );
			
			if( strcmp( "xfce", entry->d_name ) == 0 ) bool_desktop_ok = TRUE;
			if( strcmp( "cinnamon", entry->d_name ) == 0 ) bool_desktop_ok = TRUE;
			if( strcmp( "gnome", entry->d_name ) == 0 ) bool_desktop_ok = TRUE;
			if( strcmp( "kde", entry->d_name ) == 0 ) bool_desktop_ok = TRUE;
			if( strcmp( "openbox", entry->d_name ) == 0 ) bool_desktop_ok = TRUE;
		}
	}
	closedir( dp );
	
	if( FALSE == bool_desktop_ok )
		NtbDesktop_remove_list();

	return( list_dir );
}


// call from wind_main.c
//
gboolean NtbDesktop_is_ok( gchar *p_directory )
{
	DIR			*dp;
	struct dirent *entry;
	struct stat statbuf;
	gboolean	bool_desktop_ok = FALSE;
	
	if( NULL == (dp = opendir( p_directory )) ) return( bool_desktop_ok );
	chdir( p_directory );
	while( (entry = readdir(dp)) != NULL ) {
		lstat( entry->d_name, &statbuf );
		if( S_ISDIR( statbuf.st_mode )) {
			if( strcmp( ".", entry->d_name ) == 0 || strcmp( "..", entry->d_name ) == 0 ) continue;
			if( strcmp( "build", entry->d_name ) == 0 ||
				strcmp( "shared", entry->d_name ) == 0 || 
				strcmp( "sysmenu", entry->d_name ) == 0 ) continue;
						
			if( strcmp( "xfce", entry->d_name ) == 0 ) bool_desktop_ok = TRUE;
			if( strcmp( "cinnamon", entry->d_name ) == 0 ) bool_desktop_ok = TRUE;
			if( strcmp( "gnome", entry->d_name ) == 0 ) bool_desktop_ok = TRUE;
			if( strcmp( "kde", entry->d_name ) == 0 ) bool_desktop_ok = TRUE;
			if( strcmp( "openbox", entry->d_name ) == 0 ) bool_desktop_ok = TRUE;
		}
	}
	closedir( dp );
	
	return( bool_desktop_ok );
}


gchar *PtrDesktop = NULL;

void NtbDesktop_clicked( GtkButton *widget, gpointer user_data )
{
	gchar *Choice = (gchar *)user_data;
	
	// printf("NtbDesktop_clicked = %s\n", Choice );
	/*
	if( NULL == PtrDesktop ) {
		PtrDesktop = Choice;
		printf("	CAS 1 \n" );
		printf("Config.path_folder_manjaro_profiles = %s/%s\n",
				Config.path_folder_manjaro_profiles,
				NtbDesktop_get_desktop_actif()
				);
	}
	else if( strcmp( PtrDesktop, Choice ) != 0 ) {
		PtrDesktop = Choice;
		printf("	CAS 2 \n" );
		printf("Config.path_folder_manjaro_profiles = %s/%s\n",
				Config.path_folder_manjaro_profiles,
				NtbDesktop_get_desktop_actif()
				);
	}
	*/
	if( NULL == PtrDesktop || strcmp( PtrDesktop, Choice ) != 0 ) {
		// printf("PtrDesktop = %s\n", PtrDesktop);
		// printf("Choice     = %s\n", Choice);
		PtrDesktop = Choice;
		// printf("Config.path_folder_manjaro_profiles = \n\t%s/%s\n",
		// 		Config.path_folder_manjaro_profiles,
		// 		NtbDesktop_get_desktop_actif()
		// 		);
		NtbPackage_set_check();
	}
}

gint NtbDesktop_compar( STRUCT_LIST_RADIO * a, STRUCT_LIST_RADIO * b )
{
	return strcmp( (char*)a->name, (char*)b->name );
}

void NtbDesktop_make_radiobutton_desktop( void )
{	
	// printf("NtbDesktop_make_radiobutton_desktop\n" );
	// destroy button and remove list
	NtbDesktop_remove_list();
		
	if( NULL != (list_dir = fileanalyze_recherche_recursive( Config.path_folder_manjaro_profiles ))) {
		
		GList	*list = NULL;
		
		// Sort List STRUCT_LIST_RADIO
		list_dir = g_list_sort( list_dir, (GCompareFunc)NtbDesktop_compar );
		
		if( NULL != ( list = g_list_first( list_dir ))) {
			
			GtkWidget	*WBox = GTK_WIDGET(GLADE_GET_OBJECT("box_desktop_radiobutton"));
			GtkWidget *button = NULL;
			GSList *group;
			STRUCT_LIST_RADIO *struct_list_radio = NULL;
			gint	pos;
			
			while (list) {
				if( NULL != (struct_list_radio = (STRUCT_LIST_RADIO *)list->data) ) {
					pos = g_list_position( list_dir, list );
					if( 0 == pos ) {
						struct_list_radio->button =
						button = gtk_radio_button_new_with_label( NULL, struct_list_radio->name );
						// selected by default
						gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(button), TRUE );
						gtk_box_pack_start( GTK_BOX(WBox), button, TRUE, TRUE, 0 );
						gtk_widget_show( button );
					}
					else if( 1 == pos ) {
						group = gtk_radio_button_get_group( GTK_RADIO_BUTTON(button) );
						struct_list_radio->button =
						button = gtk_radio_button_new_with_label( group, struct_list_radio->name );
						gtk_box_pack_start( GTK_BOX(WBox), button, TRUE, TRUE, 0 );
						gtk_widget_show( button );
					}
					else {
						struct_list_radio->button =
						button = gtk_radio_button_new_with_label_from_widget( GTK_RADIO_BUTTON(button), struct_list_radio->name );
						gtk_box_pack_start( GTK_BOX(WBox), button, TRUE, TRUE, 0 );
						gtk_widget_show( button );
					}
					
					g_signal_connect( (gpointer)button, "clicked", G_CALLBACK(NtbDesktop_clicked), struct_list_radio->name );
					
					if( strcmp( Config.string_choice_desktop, struct_list_radio->name ) == 0 )
						gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(button), TRUE );
					
				}
				list = g_list_next( list );
			}
		}
	}
}

gchar *NtbDesktop_get_desktop_actif( void )
{
	GList	*list = NULL;
	STRUCT_LIST_RADIO *struct_list_radio = NULL;

	if( NULL != ( list = g_list_first( list_dir ))) {
		while (list) {
			if( NULL != (struct_list_radio = (STRUCT_LIST_RADIO *)list->data)) {
				
				if( TRUE == gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(struct_list_radio->button) )) {
					return( (gchar *)struct_list_radio->name );
				}
				
			}
			list = g_list_next( list );
		}
	}
	return( (gchar *)NULL );
}

gchar *NtbDesktop_get_first_name_desktop_actif( void )
{
	gchar	**Larrbuf = NULL;
	gchar	*Ptr = NULL;
	gchar	*Name = NULL;
		
	// Split name5-desktop-truc
	Larrbuf = g_strsplit( NtbDesktop_get_desktop_actif(), "-", 0 );
	Name = g_strdup( Larrbuf[ 0 ] );
	g_strfreev( Larrbuf );
	// Remove number in first name: 'name5' -> 'name'
	for( Ptr = Name; *Ptr; Ptr ++ )
		if( *Ptr >= '0' && *Ptr <= '9' ) {
			*Ptr = '\0';
			break;
		}
	// return 'name'
	return( (gchar *)Name );
}






